

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Brief Introduction to SoC System Control Entity &mdash; TISCI User Guide</title>
  

  
  
    <link rel="shortcut icon" href="../_static/favicon.ico"/>
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  

  
    <link rel="stylesheet" href="../_static/theme_overrides.css" type="text/css" />
  

  
        <link rel="index" title="Index"
              href="../genindex.html"/>
        <link rel="search" title="Search" href="../search.html"/>
    <link rel="top" title="TISCI User Guide" href="../index.html"/>
        <link rel="up" title="Chapter 1: Introduction" href="index.html"/>
        <link rel="next" title="Chapter 2: TISCI Message Documentation" href="../2_tisci_msgs/index.html"/>
        <link rel="prev" title="Chapter 1: Introduction" href="index.html"/> 

  
  <script src="../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">
  <header id="tiHeader">
    <div class="top">
      <ul>
        <li id="top_logo">
          <a href="http://www.ti.com">
            <img src="../_static/img/ti_logo.png"/>
          </a>
        </li>
      </ul>
    </div>
    <div class="nav"></div>
  </header>
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../index.html" class="icon icon-home"> TISCI
          

          
          </a>

          
            
            
              <div class="version">
                19.07.00
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="index.html">Chapter 1: Introduction</a><ul class="current">
<li class="toctree-l2 current"><a class="current reference internal" href="#">Brief Introduction to SoC System Control Entity</a></li>
<li class="toctree-l2"><a class="reference internal" href="#introduction-to-the-tisci-protocol">Introduction to the TISCI protocol</a></li>
<li class="toctree-l2"><a class="reference internal" href="#functionality-available-through-the-tisci-protocol">Functionality Available Through the TISCI Protocol</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#power-and-clock-management-features">Power and Clock Management Features</a></li>
<li class="toctree-l3"><a class="reference internal" href="#resource-management-features">Resource Management Features</a></li>
<li class="toctree-l3"><a class="reference internal" href="#security-features">Security Features</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#generic-messaging-header">Generic Messaging Header</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#request-flags">Request flags</a></li>
<li class="toctree-l3"><a class="reference internal" href="#response-flags">Response flags</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#secure-messaging-header">Secure Messaging Header</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#secure-header-in-the-request-path">Secure header in the request path</a></li>
<li class="toctree-l3"><a class="reference internal" href="#secure-header-in-the-response-path">Secure header in the response path</a></li>
<li class="toctree-l3"><a class="reference internal" href="#secure-header-on-a-gp-device-vs-a-hs-device">Secure header on a GP device vs a HS device</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#gp-device">GP Device</a></li>
<li class="toctree-l4"><a class="reference internal" href="#hs-device">HS Device</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#secure-header-integrity-check-calculation">Secure header integrity check calculation</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#tisci-message-eligibility-for-secure-vs-non-secure-transport">TISCI Message Eligibility for Secure vs Non-secure transport</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../2_tisci_msgs/index.html">Chapter 2: TISCI Message Documentation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../3_boardcfg/index.html">Chapter 3: Board Configuration</a></li>
<li class="toctree-l1"><a class="reference internal" href="../4_trace/index.html">Chapter 4: Interpreting Trace Data</a></li>
<li class="toctree-l1"><a class="reference internal" href="../5_soc_doc/index.html">Chapter 5: SoC Family Specific Documentation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../6_topic_user_guides/index.html">Chapter 6: Topic User Guides</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../index.html">TISCI</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          

 



<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../index.html">Docs</a> &raquo;</li>
      
          <li><a href="index.html">Chapter 1: Introduction</a> &raquo;</li>
      
    <li>Brief Introduction to SoC System Control Entity</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="brief-introduction-to-soc-system-control-entity">
<h1>Brief Introduction to SoC System Control Entity<a class="headerlink" href="#brief-introduction-to-soc-system-control-entity" title="Permalink to this headline">¶</a></h1>
<p>Traditional Texas Instruments SoCs implement system control functions such as
power management within operating systems on each of the processing units
(ARM/DSP etc). However, the traditional approach has had tremendous challenges
to ensure system stability. A few of the challenges include:</p>
<ul class="simple">
<li>Complex interactions between Operating Systems on heterogeneous SoCs for
generic features.</li>
<li>Lack of centralized knowledge of system state.</li>
<li>Complex implementation challenges with regards to implementation of
workarounds for system quirks.</li>
<li>Equivalent system capability entitlement on all variations of operation
conditions.</li>
</ul>
<p>Texas Instruments’ System Control Interface (TISCI) defines the communication
protocol between various processing entities to the System Control Entity on
TI SoCs. This is a set of message formats and sequence of operations required
to communicate and get system services processed from the System Control Entity
in the SoC.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p>The majority of users will not need to use TISCI since they will
use Processor SDK Linux/RTOS services. For users that do not use
Processor SDK, TISCI is provided to access system services.</p>
<p class="last">An example of when you may need to make use of TISCI is for the
implementation of another operating system. Users can look at the
integration in Processor SDK for an example.</p>
</div>
</div>
<div class="section" id="introduction-to-the-tisci-protocol">
<h1>Introduction to the TISCI protocol<a class="headerlink" href="#introduction-to-the-tisci-protocol" title="Permalink to this headline">¶</a></h1>
<p>The Primary goal of the TISCI protocol is to be SoC independent. To achieve
this, the following rules are followed by TISCI protocol:</p>
<ul class="simple">
<li>Limited in scope to SoC boundary<ul>
<li>Entities outside the SoC boundary are not directly controlled by the
TISCI protocol.</li>
</ul>
</li>
<li>Centralized control of SoC system
functions including power management, resource management, and security.
This implies that operating systems do not directly access any of the
hardware modules that control system functions such as power management,
instead TISCI will be used.</li>
<li>SoC comprises of multiple hardware blocks, hence all
abstractions are at the hardware block level. This implies that if the I2C2
instance is to be requested, then the I2C2 device is requested and the clock
frequency, for example, is referenced from I2C2’s perspective. Hence, if the
OS driver controlling I2C2 needs to know the functional clock frequency it
makes a TISCI request for I2C2 functional clock frequency.</li>
</ul>
</div>
<div class="section" id="functionality-available-through-the-tisci-protocol">
<h1>Functionality Available Through the TISCI Protocol<a class="headerlink" href="#functionality-available-through-the-tisci-protocol" title="Permalink to this headline">¶</a></h1>
<div class="section" id="power-and-clock-management-features">
<h2>Power and Clock Management Features<a class="headerlink" href="#power-and-clock-management-features" title="Permalink to this headline">¶</a></h2>
<p>Public APIs are provided to:</p>
<ul class="simple">
<li>Enable and release a module, such as a UART or a core<ul>
<li>This configures both power and clock details for the module and keeps
track of its usage.</li>
</ul>
</li>
<li>Configure the lowest/deepest low-power (sleep) mode allowed as well as EMIF
details to enable self-refresh</li>
<li>Query thermal sensors</li>
</ul>
</div>
<div class="section" id="resource-management-features">
<h2>Resource Management Features<a class="headerlink" href="#resource-management-features" title="Permalink to this headline">¶</a></h2>
<p>Public APIs are provided to:</p>
<ul class="simple">
<li>Manage DMA/Navigator Resources<ul>
<li>UDMAP</li>
<li>Ring Accelerator</li>
<li>PSI-L</li>
<li>Proxy</li>
</ul>
</li>
<li>Program interrupts (interrupt aggregators and routers) both
at SoC and subsystem (DMA/Navigator) level</li>
</ul>
</div>
<div class="section" id="security-features">
<h2>Security Features<a class="headerlink" href="#security-features" title="Permalink to this headline">¶</a></h2>
<p>Public APIs are provided to directly configure these features following
polices and root of trust:</p>
<ul class="simple">
<li>ISC<ul>
<li>Present at originator/master interfaces to control credentials from master</li>
</ul>
</li>
<li>Firewall<ul>
<li>Additional layer of access control beyond MMU/MPU located at each
destination/slave interface to control memory and register access</li>
</ul>
</li>
<li>SA2-UL Security Contexts<ul>
<li>Contains actual keys for crypto accelerator</li>
</ul>
</li>
</ul>
<p>APIs are also provided to authenticate and/or decrypt blobs in memory.</p>
</div>
</div>
<div class="section" id="generic-messaging-header">
<h1>Generic Messaging Header<a class="headerlink" href="#generic-messaging-header" title="Permalink to this headline">¶</a></h1>
<p>All messages are prefixed by a header. This header is always present for
transmit or receive messages. The format is as follows:</p>
<p><p><strong>struct tisci_header</strong></p>
<p>Header that prefixes all TISCI messages.</p>
<table border="1" class="docutils">
<colgroup>
<col width="18%" />
<col width="11%" />
<col width="71%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>type</td>
<td>u16</td>
<td>Type of message identified by a TISCI_MSG_* ID</td>
</tr>
<tr class="row-odd"><td>host</td>
<td>u8</td>
<td>Host of the message.</td>
</tr>
<tr class="row-even"><td>seq</td>
<td>u8</td>
<td>Message identifier indicating a transfer sequence.</td>
</tr>
<tr class="row-odd"><td>flags</td>
<td>u32</td>
<td>TISCI_MSG_FLAG_* for the message.</td>
</tr>
</tbody>
</table>
</p>
<p>The <code class="docutils literal"><span class="pre">host</span></code> field must contain a value from the
<a class="reference internal" href="../5_soc_doc/am6x/hosts.html"><span class="doc">Valid SoC Host ID List</span></a>
that corresponds to the host actually sending the message as identified</p>
<p>The <code class="docutils literal"><span class="pre">seq</span></code> field is a sequence number that will be returned back to the user
for the response corresponding to the message. It is up to the user to define
<code class="docutils literal"><span class="pre">seq</span></code> in whatever way they choose. The primary intent of this field is to
allow for the queueing of multiple messages on different priority queues while
still being able to identify the response to the specific message that was
transmitted.</p>
<p>The following generic flags are available for the <code class="docutils literal"><span class="pre">flags</span></code> field:</p>
<div class="section" id="request-flags">
<h2>Request flags<a class="headerlink" href="#request-flags" title="Permalink to this headline">¶</a></h2>
<p><p><code class="docutils literal"><span class="pre">TISCI_MSG_FLAG_RESERVED0</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">BIT(0)</span></code></p>
<p>This flag is reserved and not to be used.</p>
</p>
<p><p><code class="docutils literal"><span class="pre">TISCI_MSG_FLAG_AOP</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">BIT(1)</span></code></p>
<p>ACK on Processed: Send a response to a message after it has been processed
 with TISCI_MSG_FLAG_ACK set if the processing succeeded, or a NAK otherwise.
 This response contains the complete response to the message with the result
 of the actual action that was requested.</p>
</p>
<div class="admonition warning">
<p class="first admonition-title">Warning</p>
<p class="last">It is critical that the TISCI_MSG_FLAG_AOP is set (often
TISCI_MSG_FLAG_AOP is the desired option) if a proper response is
required, as without any ACK requested no response will be sent at all,
even in the case of failure. If no response is acceptable this warning
can be disregarded.</p>
</div>
</div>
<div class="section" id="response-flags">
<h2>Response flags<a class="headerlink" href="#response-flags" title="Permalink to this headline">¶</a></h2>
<p><p><code class="docutils literal"><span class="pre">TISCI_MSG_FLAG_ACK</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">BIT(1)</span></code></p>
<p>Response flag for a message that indicates success. If this flag is NOT
 set then that is to be interpreted as a NAK.</p>
</p>
</div>
</div>
<div class="section" id="secure-messaging-header">
<h1>Secure Messaging Header<a class="headerlink" href="#secure-messaging-header" title="Permalink to this headline">¶</a></h1>
<p>All messages received by System Firmware through a secure transport must include
a “Secure Messaging Header” in addition to the “Generic Messaging Header”. The
“Secure Messaging Header” allows System Firmware to verify that the message has
been received intact. The format is as follows.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The Secure Messaging Header is only required when sending messages over
secure transport. Messages sent over non-secure transport must not
contain the secure messaging header.</p>
</div>
<p><p><strong>struct tisci_sec_header</strong></p>
<p>Header that prefixes all TISCI messages sent via secure transport.</p>
<table border="1" class="docutils">
<colgroup>
<col width="8%" />
<col width="5%" />
<col width="88%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>integ_check</td>
<td>u16</td>
<td>This field should always be initialized to zero on GP devices. The mechanism to calculate the integrity check for HS devices is under definition.</td>
</tr>
<tr class="row-odd"><td>rsvd</td>
<td>u16</td>
<td>Reserved field for future use. Initialize to zero.</td>
</tr>
</tbody>
</table>
</p>
<div class="figure" id="id1">
<img alt="../_images/secure-header.png" src="../_images/secure-header.png" />
<p class="caption"><span class="caption-number">Fig. 1 </span><span class="caption-text">Secure Messaging Header format</span></p>
</div>
<ol class="arabic simple">
<li>The Secure header is mandatory for all messages that are received via secure
transports. In AM6x devices, secure transport is a secure proxy thread that
has been marked as secure.</li>
<li>The secure header is placed before a TI SCI message. We chose this header
placement as it is akin to wrapping a TISCI message in a secure header.
Processing of the secure header can happen in a separate layer on both the
transmitter and the receiver. Rest of the code can be unaware of the secure
header.</li>
<li>The first two bytes of the secure header are used for storing the
integrity check field.</li>
<li>The next two bytes of the secure header are reserved for future use and are
initialized to zero.</li>
</ol>
<div class="section" id="secure-header-in-the-request-path">
<h2>Secure header in the request path<a class="headerlink" href="#secure-header-in-the-request-path" title="Permalink to this headline">¶</a></h2>
<p>The maximum length of the data that needs to be integrity checked is 56 bytes.
Of these 8 bytes are taken up by the standard TISCI header, 4 bytes by the
secure header leaving 44 bytes for the payload.</p>
<div class="figure" id="id2">
<img alt="../_images/user-integrity-check-calculation.png" src="../_images/user-integrity-check-calculation.png" />
<p class="caption"><span class="caption-number">Fig. 2 </span><span class="caption-text">Integrity Check calculation in the request path</span></p>
</div>
<p>The user is expected to</p>
<ol class="arabic simple">
<li>Prepare the TISCI message as usual.</li>
<li>Prepend the secure header initialized to zero. In the memory layout, the
secure header should be followed by the TISCI header. TISCI header should be
followed by the payload.</li>
</ol>
<p>3. The value of the integrity check is calculated as described in
<a class="reference internal" href="#tisci-sec-hdr-integ-check-calc"><span class="std std-ref">Secure header integrity check calculation</span></a>.</p>
<ol class="arabic" start="4">
<li><p class="first">The calculated value of the integrity check is inserted MSB first into the
secure header extension.</p>
<div class="highlight-c"><div class="highlight"><pre><span></span><span class="n">integ_check</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="n">MSB</span><span class="p">(</span><span class="n">calc_val</span><span class="p">)</span>
<span class="n">integ_check</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="n">LSB</span><span class="p">(</span><span class="n">calc_val</span><span class="p">)</span>
</pre></div>
</div>
</li>
<li><p class="first">Send the message to System Firmware via the chosen transport.</p>
</li>
</ol>
</div>
<div class="section" id="secure-header-in-the-response-path">
<h2>Secure header in the response path<a class="headerlink" href="#secure-header-in-the-response-path" title="Permalink to this headline">¶</a></h2>
<p>In the response path, System Firmware populates the integrity check in the same
manner for all responses via a secure transport. The sender of the message can
verify the integrity check before processing the response.</p>
</div>
<div class="section" id="secure-header-on-a-gp-device-vs-a-hs-device">
<h2>Secure header on a GP device vs a HS device<a class="headerlink" href="#secure-header-on-a-gp-device-vs-a-hs-device" title="Permalink to this headline">¶</a></h2>
<div class="section" id="gp-device">
<h3>GP Device<a class="headerlink" href="#gp-device" title="Permalink to this headline">¶</a></h3>
<p>The Secure Messaging header <strong>is not processed by System Firmware on a GP
device</strong>. So the host sending the TISCI request can populate the Secure
Messaging Header with zeros.</p>
<p>To maintain API compatiblity between GP and HS devices, all messages sent or
received from System Firmware via a secure transport must include the Secure
Messaging Header.</p>
</div>
<div class="section" id="hs-device">
<h3>HS Device<a class="headerlink" href="#hs-device" title="Permalink to this headline">¶</a></h3>
<p>On a HS device, System Firmware processes the integrity check field. The
integrity check field needs to be correctly populated as per the defined
integrity check function for HS devices.</p>
</div>
</div>
<div class="section" id="secure-header-integrity-check-calculation">
<span id="tisci-sec-hdr-integ-check-calc"></span><h2>Secure header integrity check calculation<a class="headerlink" href="#secure-header-integrity-check-calculation" title="Permalink to this headline">¶</a></h2>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The integrity check function for HS devices will be defined with the release
of the HS devices.</p>
</div>
</div>
</div>
<div class="section" id="tisci-message-eligibility-for-secure-vs-non-secure-transport">
<h1>TISCI Message Eligibility for Secure vs Non-secure transport<a class="headerlink" href="#tisci-message-eligibility-for-secure-vs-non-secure-transport" title="Permalink to this headline">¶</a></h1>
<p>Certain messages are only eligible to be sent over secure transport due
to the nature of the services they offer. However, all messages are able be
sent on secure queues, even when supported on non-secure queues as well.
However, it must be considered that messages that can be sent on either
secure or non-secure transport must have the tisci_sec_header <strong>only</strong>
when being sent over secure transport.</p>
<p>Each message has a table under a <em>Usage</em> section that describes whether a
message is limited to being sent over secure queues only.</p>
</div>


           </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../2_tisci_msgs/index.html" class="btn btn-neutral float-right" title="Chapter 2: TISCI Message Documentation" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="index.html" class="btn btn-neutral" title="Chapter 1: Introduction" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
      <a href="http://www.ti.com/corp/docs/legal/copyright.shtml">&copy; Copyright 2016-2019</a>, Texas Instruments Incorporated. All rights reserved. <br>
      <a href="http://www.ti.com/corp/docs/legal/trademark/trademrk.htm">Trademarks</a> | <a href="http://www.ti.com/corp/docs/legal/privacy.shtml">Privacy policy</a> | <a href="http://www.ti.com/corp/docs/legal/termsofuse.shtml">Terms of use</a> | <a href="http://www.ti.com/lsds/ti/legal/termsofsale.page">Terms of sale</a>

    </p>
  </div> 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../',
            VERSION:'19.07.00',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../_static/jquery.js"></script>
      <script type="text/javascript" src="../_static/underscore.js"></script>
      <script type="text/javascript" src="../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

    <script src="http://www.ti.com/assets/js/headerfooter/analytics.js" type="text/javascript" charset="utf-8"></script>

  

  
  
    <script type="text/javascript" src="../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
        });

      var menuHeight = window.innerHeight;

      var contentOffset = $(".wy-nav-content-wrap").offset();
      var contentHeight = $(".wy-nav-content-wrap").height();
      var contentBottom = contentOffset.top + contentHeight;

      function setNavbarTop() {
          var scrollTop = $(window).scrollTop();
          var maxTop = scrollTop + menuHeight;

          // If past the header
          if (scrollTop > contentOffset.top && maxTop < contentBottom) {
            stickyTop = scrollTop - contentOffset.top;
          } else if (maxTop > contentBottom) {
            stickyTop = scrollTop - contentOffset.top - (maxTop - contentBottom);
          } else {
            stickyTop = 0;
          }

          $(".wy-nav-side").css("top", stickyTop);
      }

      $(document).ready(function() {
        setNavbarTop();
        $(window).scroll(function () {
          setNavbarTop();
        });

        $('body').on("mousewheel", function () {
            // Remove default behavior
            event.preventDefault();
            // Scroll without smoothing
            var wheelDelta = event.wheelDelta;
            var currentScrollPosition = window.pageYOffset;
            window.scrollTo(0, currentScrollPosition - wheelDelta);
        });
      });
  </script>
   

</body>
</html>